'use strict';











var _istanbulLibInstrument = require('istanbul-lib-instrument');

var _jestRuntime = require('jest-runtime');

module.exports = function (
source,
filename,
globalConfig,
config)
{
  const coverageOptions = {
    collectCoverage: globalConfig.collectCoverage,
    collectCoverageFrom: globalConfig.collectCoverageFrom,
    collectCoverageOnlyFrom: globalConfig.collectCoverageOnlyFrom,
    mapCoverage: globalConfig.mapCoverage };

  if ((0, _jestRuntime.shouldInstrument)(filename, coverageOptions, config)) {
    // Transform file without instrumentation first, to make sure produced
    // source code is ES6 (no flowtypes etc.) and can be instrumented
    const transformResult = new _jestRuntime.ScriptTransformer(config).transformSource(
    filename,
    source,
    false,
    globalConfig.mapCoverage);

    const instrumenter = (0, _istanbulLibInstrument.createInstrumenter)();
    instrumenter.instrumentSync(transformResult.code, filename);
    return {
      coverage: instrumenter.fileCoverage,
      sourceMapPath: transformResult.sourceMapPath };

  } else {
    return null;
  }
}; // $FlowFixMe: Missing ESM export
/**
 * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 *
 * 
 */