'use strict';











var _console = require('console');
var _util = require('util');
var _callsites = require('callsites');var _callsites2 = _interopRequireDefault(_callsites);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} /**
                                                                                                                                                                                          * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                                                                                                                                                          *
                                                                                                                                                                                          * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                          * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                          * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                          *
                                                                                                                                                                                          * 
                                                                                                                                                                                          */class BufferedConsole extends _console.Console {constructor() {const buffer = [];super({ write: message => BufferedConsole.write(buffer, 'log', message) });this._buffer = buffer;
  }

  static write(
  buffer,
  type,
  message,
  level)
  {
    const call = (0, _callsites2.default)()[level != null ? level : 2];
    const origin = call.getFileName() + ':' + call.getLineNumber();
    buffer.push({ message, origin, type });
    return buffer;
  }

  log() {
    BufferedConsole.write(this._buffer, 'log', _util.format.apply(null, arguments));
  }

  info() {
    BufferedConsole.write(this._buffer, 'info', _util.format.apply(null, arguments));
  }

  warn() {
    BufferedConsole.write(this._buffer, 'warn', _util.format.apply(null, arguments));
  }

  error() {
    BufferedConsole.write(this._buffer, 'error', _util.format.apply(null, arguments));
  }

  getBuffer() {
    return this._buffer;
  }}


module.exports = BufferedConsole;