'use strict';









var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);

var _colorize = require('./colorize');var _colorize2 = _interopRequireDefault(_colorize);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} /**
                                                                                                                                                                                        * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                                                                                                                                                        *
                                                                                                                                                                                        * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                        * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                        * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                        *
                                                                                                                                                                                        * 
                                                                                                                                                                                        */const DOTS = '...';const ENTER = '⏎';module.exports = (testName, pattern, width) => {const inlineTestName = testName.replace(/(\r\n|\n|\r)/gm, ENTER);let regexp;

  try {
    regexp = new RegExp(pattern, 'i');
  } catch (e) {
    return _chalk2.default.dim(inlineTestName);
  }

  const match = inlineTestName.match(regexp);

  if (!match) {
    return _chalk2.default.dim(inlineTestName);
  }

  // $FlowFixMe
  const startPatternIndex = Math.max(match.index, 0);
  const endPatternIndex = startPatternIndex + match[0].length;

  if (inlineTestName.length <= width) {
    return (0, _colorize2.default)(inlineTestName, startPatternIndex, endPatternIndex);
  }

  const slicedTestName = inlineTestName.slice(0, width - DOTS.length);

  if (startPatternIndex < slicedTestName.length) {
    if (endPatternIndex > slicedTestName.length) {
      return (0, _colorize2.default)(
      slicedTestName + DOTS,
      startPatternIndex,
      slicedTestName.length + DOTS.length);

    } else {
      return (0, _colorize2.default)(
      slicedTestName + DOTS,
      Math.min(startPatternIndex, slicedTestName.length),
      endPatternIndex);

    }
  }

  return `${_chalk2.default.dim(slicedTestName)}${_chalk2.default.reset(DOTS)}`;
};