'use strict';
















var _jestUtil = require('jest-util');
var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _isCi = require('is-ci');var _isCi2 = _interopRequireDefault(_isCi);
var _base_reporter = require('./base_reporter');var _base_reporter2 = _interopRequireDefault(_base_reporter);
var _Status = require('./Status');var _Status2 = _interopRequireDefault(_Status);
var _get_console_output = require('./get_console_output');var _get_console_output2 = _interopRequireDefault(_get_console_output);
var _get_result_header = require('./get_result_header');var _get_result_header2 = _interopRequireDefault(_get_result_header);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}




const TITLE_BULLET = _chalk2.default.bold('\u25cf '); /**
                                                       * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                       *
                                                       * This source code is licensed under the BSD-style license found in the
                                                       * LICENSE file in the root directory of this source tree. An additional grant
                                                       * of patent rights can be found in the PATENTS file in the same directory.
                                                       *
                                                       * 
                                                       */ /* global stream$Writable, tty$WriteStream */const isInteractive = process.stdin.isTTY && !_isCi2.default;class DefaultReporter extends _base_reporter2.default {



  constructor(globalConfig) {
    super();
    this._globalConfig = globalConfig;
    this._clear = '';
    this._out = process.stdout.write.bind(process.stdout);
    this._err = process.stderr.write.bind(process.stderr);
    this._status = new _Status2.default();
    this._bufferedOutput = new Set();
    this._wrapStdio(process.stdout);
    this._wrapStdio(process.stderr);
    this._status.onChange(() => {
      this._clearStatus();
      this._printStatus();
    });
  } // ANSI clear sequence for the last printed status

  _wrapStdio(stream) {
    const originalWrite = stream.write;

    let buffer = [];
    let timeout = null;

    const flushBufferedOutput = () => {
      const string = buffer.join('');
      buffer = [];

      // This is to avoid conflicts between random output and status text
      this._clearStatus();
      if (string) {
        originalWrite.call(stream, string);
      }
      this._printStatus();

      this._bufferedOutput.delete(flushBufferedOutput);
    };

    this._bufferedOutput.add(flushBufferedOutput);

    const debouncedFlush = () => {
      // If the process blows up no errors would be printed.
      // There should be a smart way to buffer stderr, but for now
      // we just won't buffer it.
      if (stream === process.stderr) {
        flushBufferedOutput();
      } else {
        if (!timeout) {
          timeout = setTimeout(() => {
            flushBufferedOutput();
            timeout = null;
          }, 100);
        }
      }
    };

    // $FlowFixMe
    stream.write = chunk => {
      buffer.push(chunk);
      debouncedFlush();
      return true;
    };
  }

  // Don't wait for the debounced call and flush all output immediately.
  forceFlushBufferedOutput() {
    for (const flushBufferedOutput of this._bufferedOutput) {
      flushBufferedOutput();
    }
  }

  _clearStatus() {
    if (isInteractive) {
      if (this._globalConfig.useStderr) {
        this._err(this._clear);
      } else {
        this._out(this._clear);
      }
    }
  }

  _printStatus() {var _status$get =
    this._status.get();const content = _status$get.content,clear = _status$get.clear;
    this._clear = clear;
    if (isInteractive) {
      if (this._globalConfig.useStderr) {
        this._err(content);
      } else {
        this._out(content);
      }
    }
  }

  onRunStart(
  aggregatedResults,
  options)
  {
    this._status.runStarted(aggregatedResults, options);
  }

  onTestStart(test) {
    this._status.testStarted(test.path, test.context.config);
  }

  onRunComplete() {
    this.forceFlushBufferedOutput();
    this._status.runFinished();
    // $FlowFixMe
    process.stdout.write = this._out;
    // $FlowFixMe
    process.stderr.write = this._err;
    (0, _jestUtil.clearLine)(process.stderr);
  }

  onTestResult(
  test,
  testResult,
  aggregatedResults)
  {
    this._status.testFinished(
    test.context.config,
    testResult,
    aggregatedResults);

    this._printTestFileSummary(
    testResult.testFilePath,
    test.context.config,
    testResult);

    this.forceFlushBufferedOutput();
  }

  _printTestFileSummary(
  testPath,
  config,
  result)
  {
    if (!result.skipped) {
      this.log((0, _get_result_header2.default)(result, config));

      const consoleBuffer = result.console;
      if (consoleBuffer && consoleBuffer.length) {
        this.log(
        '  ' +
        TITLE_BULLET +
        'Console\n\n' +
        (0, _get_console_output2.default)(
        config.rootDir,
        !!this._globalConfig.verbose,
        consoleBuffer));


      }

      if (result.failureMessage) {
        this.log(result.failureMessage);
      }
    }
  }}


module.exports = DefaultReporter;