'use strict';












var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _utils = require('./utils');function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} /**
                                                                                                                               * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                                                                                               *
                                                                                                                               * This source code is licensed under the BSD-style license found in the
                                                                                                                               * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                               * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                               *
                                                                                                                               * 
                                                                                                                               */const LONG_TEST_COLOR = _chalk2.default.reset.bold.bgRed; // Explicitly reset for these messages since they can get written out in the
// middle of error logging
const FAIL = _chalk2.default.reset.inverse.bold.red(' FAIL ');const PASS = _chalk2.default.reset.inverse.bold.green(' PASS ');module.exports = (result, config) => {const testPath = result.testFilePath;const status =
  result.numFailingTests > 0 || result.testExecError ? FAIL : PASS;

  const runTime = result.perfStats ?
  (result.perfStats.end - result.perfStats.start) / 1000 :
  null;

  const testDetail = [];
  if (runTime !== null && runTime > 5) {
    testDetail.push(LONG_TEST_COLOR(runTime + 's'));
  }

  if (result.memoryUsage) {
    const toMB = bytes => Math.floor(bytes / 1024 / 1024);
    testDetail.push(`${toMB(result.memoryUsage)} MB heap size`);
  }

  return (
    `${status} ${(0, _utils.formatTestPath)(config, testPath)}` + (
    testDetail.length ? ` (${testDetail.join(', ')})` : ''));

};