'use strict';













var _path = require('path');var _path2 = _interopRequireDefault(_path);
var _util = require('util');var _util2 = _interopRequireDefault(_util);
var _nodeNotifier = require('node-notifier');var _nodeNotifier2 = _interopRequireDefault(_nodeNotifier);
var _base_reporter = require('./base_reporter');var _base_reporter2 = _interopRequireDefault(_base_reporter);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

const isDarwin = process.platform === 'darwin'; /**
                                                * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                *
                                                * This source code is licensed under the BSD-style license found in the
                                                * LICENSE file in the root directory of this source tree. An additional grant
                                                * of patent rights can be found in the PATENTS file in the same directory.
                                                *
                                                * 
                                                */const icon = _path2.default.resolve(__dirname, '../assets/jest_logo.png');class NotifyReporter extends _base_reporter2.default {constructor(
  globalConfig,
  startRun)
  {
    super();
    this._globalConfig = globalConfig;
    this._startRun = startRun;
  }

  onRunComplete(contexts, result) {
    const success =
    result.numFailedTests === 0 && result.numRuntimeErrorTestSuites === 0;

    if (success) {
      const title = _util2.default.format('%d%% Passed', 100);
      const message = _util2.default.format(
      (isDarwin ? '\u2705 ' : '') + '%d tests passed',
      result.numPassedTests);


      _nodeNotifier2.default.notify({ icon, message, title });
    } else {
      const failed = result.numFailedTests / result.numTotalTests;

      const title = _util2.default.format(
      '%d%% Failed',
      Math.ceil(Number.isNaN(failed) ? 0 : failed * 100));

      const message = _util2.default.format(
      (isDarwin ? '\u26D4\uFE0F ' : '') + '%d of %d tests failed',
      result.numFailedTests,
      result.numTotalTests);


      const restartAnswer = 'Run again';
      const quitAnswer = 'Exit tests';
      _nodeNotifier2.default.notify(
      {
        actions: [restartAnswer, quitAnswer],
        closeLabel: 'Close',
        icon,
        message,
        title },

      (err, _, metadata) => {
        if (err || !metadata) {
          return;
        }
        if (metadata.activationValue === quitAnswer) {
          process.exit(0);
          return;
        }
        if (metadata.activationValue === restartAnswer) {
          this._startRun(this._globalConfig);
        }
      });

    }
  }}


module.exports = NotifyReporter;