'use strict';
















var _fs = require('fs');var _fs2 = _interopRequireDefault(_fs);
var _jestUtil = require('jest-util');
var _jestConfig = require('jest-config');
var _jestDocblock = require('jest-docblock');var _jestDocblock2 = _interopRequireDefault(_jestDocblock);
var _buffered_console = require('./lib/buffered_console');var _buffered_console2 = _interopRequireDefault(_buffered_console);
var _get_console_output = require('./reporters/get_console_output');var _get_console_output2 = _interopRequireDefault(_get_console_output);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };} /**
                                                                                                                                                                                                                                          * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                          * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                          * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                                                          * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                                                          *
                                                                                                                                                                                                                                          * 
                                                                                                                                                                                                                                          */function runTest(path, globalConfig, config, resolver) {let testSource;

  try {
    testSource = _fs2.default.readFileSync(path, 'utf8');
  } catch (e) {
    return Promise.reject(e);
  }

  const parsedDocblock = _jestDocblock2.default.parse(_jestDocblock2.default.extract(testSource));
  const customEnvironment = parsedDocblock['jest-environment'];
  let testEnvironment = config.testEnvironment;

  if (customEnvironment) {
    testEnvironment = (0, _jestConfig.getTestEnvironment)(
    Object.assign({}, config, {
      testEnvironment: customEnvironment }));


  }

  /* $FlowFixMe */
  const TestEnvironment = require(testEnvironment);
  /* $FlowFixMe */
  const testFramework = require(config.testRunner);
  /* $FlowFixMe */
  const Runtime = require(config.moduleLoader || 'jest-runtime');



  const environment = new TestEnvironment(config);
  const consoleOut = globalConfig.useStderr ? process.stderr : process.stdout;
  const consoleFormatter = (type, message) =>
  (0, _get_console_output2.default)(
  config.rootDir,
  !!globalConfig.verbose,
  // 4 = the console call is buried 4 stack frames deep
  _buffered_console2.default.write([], type, message, 4));


  let testConsole;
  if (globalConfig.verbose) {
    testConsole = new _jestUtil.Console(consoleOut, process.stderr, consoleFormatter);
  } else {
    if (globalConfig.silent) {
      testConsole = new _jestUtil.NullConsole(
      consoleOut,
      process.stderr,
      consoleFormatter);

    } else {
      testConsole = new _buffered_console2.default();
    }
  }

  const cacheFS = { [path]: testSource };
  (0, _jestUtil.setGlobal)(environment.global, 'console', testConsole);
  const runtime = new Runtime(config, environment, resolver, cacheFS, {
    collectCoverage: globalConfig.collectCoverage,
    collectCoverageFrom: globalConfig.collectCoverageFrom,
    collectCoverageOnlyFrom: globalConfig.collectCoverageOnlyFrom,
    mapCoverage: globalConfig.mapCoverage });

  const start = Date.now();
  return testFramework(globalConfig, config, environment, runtime, path).
  then(result => {
    const testCount =
    result.numPassingTests +
    result.numFailingTests +
    result.numPendingTests;
    result.perfStats = { end: Date.now(), start };
    result.testFilePath = path;
    result.coverage = runtime.getAllCoverageInfo();
    result.sourceMaps = runtime.getSourceMapInfo();
    result.console = testConsole.getBuffer();
    result.skipped = testCount === result.numPendingTests;
    return result;
  }).
  then(
  result =>
  Promise.resolve().then(() => {
    environment.dispose();
    if (config.logHeapUsage) {
      if (global.gc) {
        global.gc();
      }
      result.memoryUsage = process.memoryUsage().heapUsed;
    }

    // Delay the resolution to allow log messages to be output.
    return new Promise(resolve => setImmediate(() => resolve(result)));
  }),
  err =>
  Promise.resolve().then(() => {
    environment.dispose();
    throw err;
  }));

}

module.exports = runTest;