'use strict';var _slicedToArray = function () {function sliceIterator(arr, i) {var _arr = [];var _n = true;var _d = false;var _e = undefined;try {for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {_arr.push(_s.value);if (i && _arr.length === i) break;}} catch (err) {_d = true;_e = err;} finally {try {if (!_n && _i["return"]) _i["return"]();} finally {if (_d) throw _e;}}return _arr;}return function (arr, i) {if (Array.isArray(arr)) {return arr;} else if (Symbol.iterator in Object(arr)) {return sliceIterator(arr, i);} else {throw new TypeError("Invalid attempt to destructure non-iterable instance");}};}();


















var _jestMessageUtil = require('jest-message-util');
var _test_result_helpers = require('./test_result_helpers');




var _jestSnapshot = require('jest-snapshot');var _jestSnapshot2 = _interopRequireDefault(_jestSnapshot);
var _pify = require('pify');var _pify2 = _interopRequireDefault(_pify);
var _throat = require('throat');var _throat2 = _interopRequireDefault(_throat);
var _workerFarm = require('worker-farm');var _workerFarm2 = _interopRequireDefault(_workerFarm);
var _default_reporter = require('./reporters/default_reporter');var _default_reporter2 = _interopRequireDefault(_default_reporter);
var _notify_reporter = require('./reporters/notify_reporter');var _notify_reporter2 = _interopRequireDefault(_notify_reporter);
var _summary_reporter = require('./reporters/summary_reporter');var _summary_reporter2 = _interopRequireDefault(_summary_reporter);
var _verbose_reporter = require('./reporters/verbose_reporter');var _verbose_reporter2 = _interopRequireDefault(_verbose_reporter);
var _run_test = require('./run_test');var _run_test2 = _interopRequireDefault(_run_test);
var _test_watcher = require('./test_watcher');var _test_watcher2 = _interopRequireDefault(_test_watcher);
var _coverage_reporter = require('./reporters/coverage_reporter');var _coverage_reporter2 = _interopRequireDefault(_coverage_reporter);
var _reporter_dispatcher = require('./reporter_dispatcher');var _reporter_dispatcher2 = _interopRequireDefault(_reporter_dispatcher);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _asyncToGenerator(fn) {return function () {var gen = fn.apply(this, arguments);return new Promise(function (resolve, reject) {function step(key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {return Promise.resolve(value).then(function (value) {step("next", value);}, function (err) {step("throw", err);});}}return step("next");});};} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     */const SLOW_TEST_TIME = 3000;class CancelRun extends Error {constructor(message) {super(message);this.name = 'CancelRun';}}









const TEST_WORKER_PATH = require.resolve('./test_worker');

class TestRunner {




  constructor(globalConfig, options) {
    this._globalConfig = globalConfig;
    this._dispatcher = new _reporter_dispatcher2.default();
    this._options = options;
    this._setupReporters();
  }

  addReporter(reporter) {
    this._dispatcher.register(reporter);
  }

  removeReporter(ReporterClass) {
    this._dispatcher.unregister(ReporterClass);
  }

  runTests(tests, watcher) {var _this = this;return _asyncToGenerator(function* () {
      const timings = [];
      const contexts = new Set();
      tests.forEach(function (test) {
        contexts.add(test.context);
        if (test.duration) {
          timings.push(test.duration);
        }
      });

      const aggregatedResults = createAggregatedResults(tests.length);
      const estimatedTime = Math.ceil(
      getEstimatedTime(timings, _this._globalConfig.maxWorkers) / 1000);


      // Run in band if we only have one test or one worker available.
      // If we are confident from previous runs that the tests will finish quickly
      // we also run in band to reduce the overhead of spawning workers.
      const runInBand =
      _this._globalConfig.maxWorkers <= 1 ||
      tests.length <= 1 ||
      tests.length <= 20 &&
      timings.length > 0 &&
      timings.every(function (timing) {return timing < SLOW_TEST_TIME;});

      const onResult = (() => {var _ref = _asyncToGenerator(function* (test, testResult) {
          if (watcher.isInterrupted()) {
            return Promise.resolve();
          }
          if (testResult.testResults.length === 0) {
            const message = 'Your test suite must contain at least one test.';
            yield onFailure(test, {
              message,
              stack: new Error(message).stack });

            return Promise.resolve();
          }
          (0, _test_result_helpers.addResult)(aggregatedResults, testResult);
          yield _this._dispatcher.onTestResult(test, testResult, aggregatedResults);
          return _this._bailIfNeeded(contexts, aggregatedResults, watcher);
        });return function onResult(_x, _x2) {return _ref.apply(this, arguments);};})();

      const onFailure = (() => {var _ref2 = _asyncToGenerator(function* (test, error) {
          if (watcher.isInterrupted()) {
            return;
          }
          const testResult = (0, _test_result_helpers.buildFailureTestResult)(test.path, error);
          testResult.failureMessage = (0, _jestMessageUtil.formatExecError)(
          testResult,
          test.context.config,
          _this._globalConfig,
          test.path);

          (0, _test_result_helpers.addResult)(aggregatedResults, testResult);
          yield _this._dispatcher.onTestResult(test, testResult, aggregatedResults);
        });return function onFailure(_x3, _x4) {return _ref2.apply(this, arguments);};})();

      const updateSnapshotState = function () {
        contexts.forEach(function (context) {
          const status = _jestSnapshot2.default.cleanup(
          context.hasteFS,
          _this._globalConfig.updateSnapshot);

          aggregatedResults.snapshot.filesRemoved += status.filesRemoved;
        });
        const updateAll = _this._globalConfig.updateSnapshot === 'all';
        aggregatedResults.snapshot.didUpdate = updateAll;
        aggregatedResults.snapshot.failure = !!(
        !updateAll && (
        aggregatedResults.snapshot.unchecked ||
        aggregatedResults.snapshot.unmatched ||
        aggregatedResults.snapshot.filesRemoved));

      };

      yield _this._dispatcher.onRunStart(aggregatedResults, {
        estimatedTime,
        showStatus: !runInBand });


      try {
        yield runInBand ?
        _this._createInBandTestRun(tests, watcher, onResult, onFailure) :
        _this._createParallelTestRun(tests, watcher, onResult, onFailure);
      } catch (error) {
        if (!watcher.isInterrupted()) {
          throw error;
        }
      }

      updateSnapshotState();
      aggregatedResults.wasInterrupted = watcher.isInterrupted();
      yield _this._dispatcher.onRunComplete(contexts, aggregatedResults);

      const anyTestFailures = !(
      aggregatedResults.numFailedTests === 0 &&
      aggregatedResults.numRuntimeErrorTestSuites === 0);

      const anyReporterErrors = _this._dispatcher.hasErrors();

      aggregatedResults.success = !(
      anyTestFailures ||
      aggregatedResults.snapshot.failure ||
      anyReporterErrors);


      return aggregatedResults;})();
  }

  _createInBandTestRun(
  tests,
  watcher,
  onResult,
  onFailure)
  {var _this2 = this;
    const mutex = (0, _throat2.default)(1);
    return tests.reduce(
    (promise, test) =>
    mutex(() =>
    promise.
    then(_asyncToGenerator(function* () {
      if (watcher.isInterrupted()) {
        throw new CancelRun();
      }

      yield _this2._dispatcher.onTestStart(test);
      return (0, _run_test2.default)(
      test.path,
      _this2._globalConfig,
      test.context.config,
      test.context.resolver);

    })).
    then(result => onResult(test, result)).
    catch(err => onFailure(test, err))),

    Promise.resolve());

  }

  _createParallelTestRun(
  tests,
  watcher,
  onResult,
  onFailure)
  {var _this3 = this;
    const farm = (0, _workerFarm2.default)(
    {
      autoStart: true,
      maxConcurrentCallsPerWorker: 1,
      maxConcurrentWorkers: this._globalConfig.maxWorkers,
      maxRetries: 2 // Allow for a couple of transient errors.
    },
    TEST_WORKER_PATH);

    const mutex = (0, _throat2.default)(this._globalConfig.maxWorkers);
    const worker = (0, _pify2.default)(farm);

    // Send test suites to workers continuously instead of all at once to track
    // the start time of individual tests.
    const runTestInWorker = test =>
    mutex(_asyncToGenerator(function* () {
      if (watcher.isInterrupted()) {
        return Promise.reject();
      }
      yield _this3._dispatcher.onTestStart(test);
      return worker({
        config: test.context.config,
        globalConfig: _this3._globalConfig,
        path: test.path,
        rawModuleMap: watcher.isWatchMode() ?
        test.context.moduleMap.getRawModuleMap() :
        null });

    }));

    const onError = (() => {var _ref5 = _asyncToGenerator(function* (err, test) {
        yield onFailure(test, err);
        if (err.type === 'ProcessTerminatedError') {
          console.error(
          'A worker process has quit unexpectedly! ' +
          'Most likely this is an initialization error.');

          process.exit(1);
        }
      });return function onError(_x5, _x6) {return _ref5.apply(this, arguments);};})();

    const onInterrupt = new Promise((_, reject) => {
      watcher.on('change', state => {
        if (state.interrupted) {
          reject(new CancelRun());
        }
      });
    });

    const runAllTests = Promise.all(
    tests.map(test =>
    runTestInWorker(test).
    then(testResult => onResult(test, testResult)).
    catch(error => onError(error, test))));



    const cleanup = () => _workerFarm2.default.end(farm);
    return Promise.race([runAllTests, onInterrupt]).then(cleanup, cleanup);
  }

  _shouldAddDefaultReporters(reporters) {
    return (
      !reporters ||
      !!reporters.find(reporterConfig => reporterConfig[0] === 'default'));

  }

  _setupReporters() {var _globalConfig =
    this._globalConfig;const collectCoverage = _globalConfig.collectCoverage,notify = _globalConfig.notify,reporters = _globalConfig.reporters;

    const isDefault = this._shouldAddDefaultReporters(reporters);

    if (isDefault) {
      this._setupDefaultReporters();
    }

    if (collectCoverage) {
      this.addReporter(new _coverage_reporter2.default(this._globalConfig));
    }

    if (notify) {
      this.addReporter(
      new _notify_reporter2.default(this._globalConfig, this._options.startRun));

    }

    if (reporters && Array.isArray(reporters)) {
      this._addCustomReporters(reporters);
    }
  }

  _setupDefaultReporters() {
    this.addReporter(
    this._globalConfig.verbose ?
    new _verbose_reporter2.default(this._globalConfig) :
    new _default_reporter2.default(this._globalConfig));


    this.addReporter(new _summary_reporter2.default(this._globalConfig));
  }

  _addCustomReporters(reporters) {
    const customReporters = reporters.filter(
    reporterConfig => reporterConfig[0] !== 'default');


    customReporters.forEach((reporter, index) => {var _getReporterProps =
      this._getReporterProps(reporter);const options = _getReporterProps.options,path = _getReporterProps.path;

      try {
        const Reporter = require(path);
        this.addReporter(new Reporter(this._globalConfig, options));
      } catch (error) {
        throw new Error(
        'An error occurred while adding the reporter at path "' +
        path +
        '".' +
        error.message);

      }
    });
  }

  /**
     * Get properties of a reporter in an object
     * to make dealing with them less painful.
     */
  _getReporterProps(
  reporter)
  {
    if (typeof reporter === 'string') {
      return { options: this._options, path: reporter };
    } else if (Array.isArray(reporter)) {var _reporter = _slicedToArray(
      reporter, 2);const path = _reporter[0],options = _reporter[1];
      return { options, path };
    }

    throw new Error('Reporter should be either a string or an array');
  }

  _bailIfNeeded(
  contexts,
  aggregatedResults,
  watcher)
  {
    if (this._globalConfig.bail && aggregatedResults.numFailedTests !== 0) {
      if (watcher.isWatchMode()) {
        watcher.setState({ interrupted: true });
      } else {
        const exit = () => process.exit(1);
        return this._dispatcher.
        onRunComplete(contexts, aggregatedResults).
        then(exit).
        catch(exit);
      }
    }
    return Promise.resolve();
  }}


const createAggregatedResults = numTotalTestSuites => {
  const result = (0, _test_result_helpers.makeEmptyAggregatedTestResult)();
  result.numTotalTestSuites = numTotalTestSuites;
  result.startTime = Date.now();
  result.success = false;
  return result;
};

const getEstimatedTime = (timings, workers) => {
  if (!timings.length) {
    return 0;
  }

  const max = Math.max.apply(null, timings);
  return timings.length <= workers ?
  max :
  Math.max(timings.reduce((sum, time) => sum + time) / workers, max);
};

module.exports = TestRunner;