'use strict';












var _ansiEscapes = require('ansi-escapes');var _ansiEscapes2 = _interopRequireDefault(_ansiEscapes);
var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _get_changed_files_promise = require('./get_changed_files_promise');var _get_changed_files_promise2 = _interopRequireDefault(_get_changed_files_promise);
var _jestRegexUtil = require('jest-regex-util');
var _jestHasteMap = require('jest-haste-map');var _jestHasteMap2 = _interopRequireDefault(_jestHasteMap);
var _isCi = require('is-ci');var _isCi2 = _interopRequireDefault(_isCi);
var _is_valid_path = require('./lib/is_valid_path');var _is_valid_path2 = _interopRequireDefault(_is_valid_path);
var _pre_run_message = require('./pre_run_message');var _pre_run_message2 = _interopRequireDefault(_pre_run_message);
var _create_context = require('./lib/create_context');var _create_context2 = _interopRequireDefault(_create_context);
var _run_jest = require('./run_jest');var _run_jest2 = _interopRequireDefault(_run_jest);
var _update_global_config = require('./lib/update_global_config');var _update_global_config2 = _interopRequireDefault(_update_global_config);
var _search_source = require('./search_source');var _search_source2 = _interopRequireDefault(_search_source);
var _test_watcher = require('./test_watcher');var _test_watcher2 = _interopRequireDefault(_test_watcher);
var _Prompt = require('./lib/Prompt');var _Prompt2 = _interopRequireDefault(_Prompt);
var _test_path_pattern_prompt = require('./test_path_pattern_prompt');var _test_path_pattern_prompt2 = _interopRequireDefault(_test_path_pattern_prompt);
var _test_name_pattern_prompt = require('./test_name_pattern_prompt');var _test_name_pattern_prompt2 = _interopRequireDefault(_test_name_pattern_prompt);
var _constants = require('./constants');function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}

const isInteractive = process.stdout.isTTY && !_isCi2.default; /**
                                                                * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
                                                                *
                                                                * This source code is licensed under the BSD-style license found in the
                                                                * LICENSE file in the root directory of this source tree. An additional grant
                                                                * of patent rights can be found in the PATENTS file in the same directory.
                                                                *
                                                                * 
                                                                */let hasExitListener = false;const watch = function (initialGlobalConfig, contexts, outputStream, hasteMapInstances)
{let stdin = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : process.stdin;
  // `globalConfig` will be consantly updated and reassigned as a result of
  // watch mode interactions.
  let globalConfig = initialGlobalConfig;

  globalConfig = (0, _update_global_config2.default)(globalConfig, {
    mode: globalConfig.watch ? 'watch' : 'watchAll' });


  const prompt = new _Prompt2.default();
  const testPathPatternPrompt = new _test_path_pattern_prompt2.default(outputStream, prompt);
  const testNamePatternPrompt = new _test_name_pattern_prompt2.default(outputStream, prompt);
  let searchSources = contexts.map(context => ({
    context,
    searchSource: new _search_source2.default(context) }));

  let hasSnapshotFailure = false;
  let isRunning = false;
  let testWatcher;
  let shouldDisplayWatchUsage = true;
  let isWatchUsageDisplayed = false;

  testPathPatternPrompt.updateSearchSources(searchSources);

  hasteMapInstances.forEach((hasteMapInstance, index) => {
    hasteMapInstance.on('change', (_ref) => {let eventsQueue = _ref.eventsQueue,hasteFS = _ref.hasteFS,moduleMap = _ref.moduleMap;
      const validPaths = eventsQueue.filter((_ref2) => {let filePath = _ref2.filePath;
        return (0, _is_valid_path2.default)(globalConfig, contexts[index].config, filePath);
      });

      if (validPaths.length) {
        const context = contexts[index] = (0, _create_context2.default)(
        contexts[index].config,
        {
          hasteFS,
          moduleMap });


        prompt.abort();
        searchSources = searchSources.slice();
        searchSources[index] = {
          context,
          searchSource: new _search_source2.default(context) };

        testPathPatternPrompt.updateSearchSources(searchSources);
        startRun(globalConfig);
      }
    });
  });

  if (!hasExitListener) {
    hasExitListener = true;
    process.on('exit', () => {
      if (prompt.isEntering()) {
        outputStream.write(_ansiEscapes2.default.cursorDown());
        outputStream.write(_ansiEscapes2.default.eraseDown);
      }
    });
  }

  const startRun = globalConfig => {
    if (isRunning) {
      return null;
    }

    testWatcher = new _test_watcher2.default({ isWatchMode: true });
    isInteractive && outputStream.write(_constants.CLEAR);
    _pre_run_message2.default.print(outputStream);
    isRunning = true;
    const configs = contexts.map(context => context.config);
    const changedFilesPromise = (0, _get_changed_files_promise2.default)(globalConfig, configs);
    return (0, _run_jest2.default)({
      changedFilesPromise,
      contexts,
      globalConfig,
      onComplete: results => {
        isRunning = false;
        hasSnapshotFailure = !!results.snapshot.failure;
        // Create a new testWatcher instance so that re-runs won't be blocked.
        // The old instance that was passed to Jest will still be interrupted
        // and prevent test runs from the previous run.
        testWatcher = new _test_watcher2.default({ isWatchMode: true });
        if (shouldDisplayWatchUsage) {
          outputStream.write(usage(globalConfig, hasSnapshotFailure));
          shouldDisplayWatchUsage = false; // hide Watch Usage after first run
          isWatchUsageDisplayed = true;
        } else {
          outputStream.write(showToggleUsagePrompt());
          shouldDisplayWatchUsage = false;
          isWatchUsageDisplayed = false;
        }

        testNamePatternPrompt.updateCachedTestResults(results.testResults);
      },
      outputStream,
      startRun,
      testWatcher }).
    catch(error => console.error(_chalk2.default.red(error.stack)));
  };

  const onKeypress = key => {
    if (key === _constants.KEYS.CONTROL_C || key === _constants.KEYS.CONTROL_D) {
      process.exit(0);
      return;
    }

    if (prompt.isEntering()) {
      prompt.put(key);
      return;
    }

    // Abort test run
    if (
    isRunning &&
    testWatcher &&
    [_constants.KEYS.Q, _constants.KEYS.ENTER, _constants.KEYS.A, _constants.KEYS.O, _constants.KEYS.P, _constants.KEYS.T].indexOf(key) !== -1)
    {
      testWatcher.setState({ interrupted: true });
      return;
    }

    switch (key) {
      case _constants.KEYS.Q:
        process.exit(0);
        return;
      case _constants.KEYS.ENTER:
        startRun(globalConfig);
        break;
      case _constants.KEYS.U:
        globalConfig = (0, _update_global_config2.default)(globalConfig, {
          updateSnapshot: 'all' });

        startRun(globalConfig);
        globalConfig = (0, _update_global_config2.default)(globalConfig, {
          // updateSnapshot is not sticky after a run.
          updateSnapshot: 'none' });

        break;
      case _constants.KEYS.A:
        globalConfig = (0, _update_global_config2.default)(globalConfig, {
          mode: 'watchAll',
          testNamePattern: '',
          testPathPattern: '' });

        startRun(globalConfig);
        break;
      case _constants.KEYS.C:
        globalConfig = (0, _update_global_config2.default)(globalConfig, {
          mode: 'watch',
          testNamePattern: '',
          testPathPattern: '' });

        startRun(globalConfig);
        break;
      case _constants.KEYS.O:
        globalConfig = (0, _update_global_config2.default)(globalConfig, {
          mode: 'watch',
          testNamePattern: '',
          testPathPattern: '' });

        startRun(globalConfig);
        break;
      case _constants.KEYS.P:
        testPathPatternPrompt.run(
        testPathPattern => {
          globalConfig = (0, _update_global_config2.default)(globalConfig, {
            mode: 'watch',
            testNamePattern: '',
            testPathPattern: (0, _jestRegexUtil.replacePathSepForRegex)(testPathPattern) });


          startRun(globalConfig);
        },
        onCancelPatternPrompt,
        { header: activeFilters(globalConfig) });

        break;
      case _constants.KEYS.T:
        testNamePatternPrompt.run(
        testNamePattern => {
          globalConfig = (0, _update_global_config2.default)(globalConfig, {
            mode: 'watch',
            testNamePattern,
            testPathPattern: globalConfig.testPathPattern });


          startRun(globalConfig);
        },
        onCancelPatternPrompt,
        { header: activeFilters(globalConfig) });

        break;
      case _constants.KEYS.QUESTION_MARK:
        break;
      case _constants.KEYS.W:
        if (!shouldDisplayWatchUsage && !isWatchUsageDisplayed) {
          outputStream.write(_ansiEscapes2.default.cursorUp());
          outputStream.write(_ansiEscapes2.default.eraseDown);
          outputStream.write(usage(globalConfig, hasSnapshotFailure));
          isWatchUsageDisplayed = true;
          shouldDisplayWatchUsage = false;
        }
        break;}

  };

  const onCancelPatternPrompt = () => {
    outputStream.write(_ansiEscapes2.default.cursorHide);
    outputStream.write(_ansiEscapes2.default.clearScreen);
    outputStream.write(usage(globalConfig, hasSnapshotFailure));
    outputStream.write(_ansiEscapes2.default.cursorShow);
  };

  if (typeof stdin.setRawMode === 'function') {
    stdin.setRawMode(true);
    stdin.resume();
    stdin.setEncoding('hex');
    stdin.on('data', onKeypress);
  }

  startRun(globalConfig);
  return Promise.resolve();
};

const activeFilters = function (globalConfig) {let delimiter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '\n';const
  testNamePattern = globalConfig.testNamePattern,testPathPattern = globalConfig.testPathPattern;
  if (testNamePattern || testPathPattern) {
    const filters = [
    testPathPattern ?
    _chalk2.default.dim('filename ') + _chalk2.default.yellow('/' + testPathPattern + '/') :
    null,
    testNamePattern ?
    _chalk2.default.dim('test name ') + _chalk2.default.yellow('/' + testNamePattern + '/') :
    null].

    filter(f => !!f).
    join(', ');

    const messages = ['\n' + _chalk2.default.bold('Active Filters: ') + filters];

    return messages.filter(message => !!message).join(delimiter);
  }

  return '';
};

const usage = function (globalConfig, snapshotFailure) {let delimiter = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '\n';
  const messages = [
  activeFilters(globalConfig),

  globalConfig.testPathPattern || globalConfig.testNamePattern ?
  _chalk2.default.dim(' \u203A Press ') + 'c' + _chalk2.default.dim(' to clear filters.') :
  null,
  '\n' + _chalk2.default.bold('Watch Usage'),

  globalConfig.watch ?
  _chalk2.default.dim(' \u203A Press ') + 'a' + _chalk2.default.dim(' to run all tests.') :
  null,

  (globalConfig.watchAll ||
  globalConfig.testPathPattern ||
  globalConfig.testNamePattern) &&
  !globalConfig.noSCM ?
  _chalk2.default.dim(' \u203A Press ') +
  'o' +
  _chalk2.default.dim(' to only run tests related to changed files.') :
  null,

  snapshotFailure ?
  _chalk2.default.dim(' \u203A Press ') +
  'u' +
  _chalk2.default.dim(' to update failing snapshots.') :
  null,

  _chalk2.default.dim(' \u203A Press ') +
  'p' +
  _chalk2.default.dim(' to filter by a filename regex pattern.'),

  _chalk2.default.dim(' \u203A Press ') +
  't' +
  _chalk2.default.dim(' to filter by a test name regex pattern.'),

  _chalk2.default.dim(' \u203A Press ') + 'q' + _chalk2.default.dim(' to quit watch mode.'),

  _chalk2.default.dim(' \u203A Press ') +
  'Enter' +
  _chalk2.default.dim(' to trigger a test run.')];


  return messages.filter(message => !!message).join(delimiter) + '\n';
};

const showToggleUsagePrompt = () =>
'\n' +
_chalk2.default.bold('Watch Usage: ') +
_chalk2.default.dim('Press ') +
'w' +
_chalk2.default.dim(' to show more.');

module.exports = watch;